Unit QSF2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QSF2R(var INT1 :Real; var INT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; E :Real;
                L1 :Integer; L2 :Integer);

implementation

procedure QSF2R(var INT1 :Real; var INT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; E :Real;
                L1 :Integer; L2 :Integer);
var
D,IERR :Integer;
I,K,C,W,Z2,EPS,H,Z1,P,R,Q,V,T,S,U,Z,BA,BB,BD,X,Y,R1,R2 :Real;
NI :Boolean;
G :Array [0..4] of Real;
L :Array [0..4] of Real;
M :Array [0..4] of Real;
Q1 :Array [0..4] of Real;
BC :Array [0..6] of Real;
const
TDS :Real = 0.2666666;
TSO :Real = 0.7111111;
TOF :Real = 0.1555555;
SYS051 :Real = 1.192093E-7;
HMIN :Real = 1.192093E-4;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_11,_12,_13,_14,_15,_16,_17,_18,_19,_22,
_20,_21;
begin
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _2;
INT1 := 0.0;
INT2 := 0.0;
goto _21;
_2:
Z2 := E/W;
EPS := Abs(E);
H := 1.0;
Z1 := EPS/W;
P := 0.0;
INT1 := 0.0;
INT2 := 0.0;
_3:
R := H/2.0;
Q := W*R;
V := Q*RO;
T := H*0.25;
for D:=1 to 5 do
 begin
  L[D-1] := F(A+W*(P+T*(D-1)));
_4:
 end;
_5:
if ( (L1+L2)  < 1.5  ) and ( V  <= 0.25 ) 
 then goto _6;
S := Abs(L[0]+L[4]-4.0*(L[1]+L[3])+6.0*L[2]);
goto _8;
_6:
I := (A+W*(P+R))*RO+FI;
for D:=1 to 5 do
 begin
  M[D-1] := L[D-1]*Sin(I);
  Q1[D-1] := L[D-1]*Cos(I);
_7:
 end;
I := M[0]+M[4]-4.0*(M[1]+M[3])+6.0*M[2];
S := Q1[0]+Q1[4]-4.0*(Q1[1]+Q1[3])+6.0*Q1[2];
S := EMax1((L1)*Abs(I),(L2)*Abs(S));
_8:
S := S*R*0.42;
if ( H  < HMIN ) 
 then goto _22;
if ( Abs(S)-Z1 ) < 0
 then goto _12
 else if ( Abs(S)-Z1 ) > 0
       then goto _9
       else goto _9;
_9:
H := H/2;
if ( H-SYS051*P ) < 0
 then goto _22
 else if ( H-SYS051*P ) > 0
       then goto _11
       else goto _22;
_11:
L[4] := L[2];
L[2] := L[1];
R := H*0.5;
V := W*R*RO;
T := H*0.25;
U := P+T;
L[1] := F(A+W*U);
L[3] := F(A+W*(U+R));
goto _5;
_12:
I := (A+W*(P+R))*RO+FI;
Z := Sin(I);
BA := Cos(I);
Q := W*R;
BB := RO*Q;
BC[3] := Sin(BB);
BC[4] := Cos(BB);
if ( BB-0.33 ) < 0
 then goto _13
 else if ( BB-0.33 ) > 0
       then goto _14
       else goto _13;
_13:
BD := BB*0.5;
BC[5] := Sin(BD);
BC[6] := Cos(BD);
G[0] := TDS;
G[1] := TSO*BC[6];
G[2] := TOF*BC[4];
G[3] := TSO*BC[5];
G[4] := TOF*BC[3];
goto _15;
_14:
BC[0] := 1.0/BB;
BC[1] := BC[0]*BC[0];
BC[2] := BC[1]*BC[1];
G[0] := 4.0*BC[1]*(BC[0]*(48.0*BC[1]-19.0)*BC[3]+3.0*(1.0-16.0*
    BC[1])*BC[4]);
G[1] := 32.0*BC[1]*(BC[0]*(5.0-12.0*BC[1])*BC[3]-(1.0-12.0*
    BC[1])*BC[4])/3.0;
G[2] := BC[0]*((3.0-46.0*BC[1]+96.0*BC[2])*BC[3]+2.0*BC[0]*
    (7.0-48.0*BC[1])*BC[4])/3.0;
G[3] := -16.0*BC[1]*((1.0-3.0*BC[1])*BC[3]+3.0*BC[0]*BC[4])/
    3.0;
G[4] := BC[0]*(BC[0]*(11.0-24.0*BC[1])*BC[3]-3.0*(1.0-8.0*
    BC[1])*BC[4])/3.0;
_15:
X := G[0]*L[2]+G[1]*(L[1]+L[3])+G[2]*(L[0]+L[4]);
Y := G[3]*(L[3]-L[1])+G[4]*(L[4]-L[0]);
R1 := (Z*X+BA*Y)*R;
R2 := (BA*X-Z*Y)*R;
INT1 := INT1+R1;
INT2 := INT2+R2;
if ( P  = P+H ) 
 then goto _22;
P := P+H;
K := 1.0-P;
if ( K  <= 0 ) 
 then goto _20;
_16:
L[0] := L[4];
if ( Abs(S)-Z1/32.0 ) < 0
 then goto _17
 else if ( Abs(S)-Z1/32.0 ) > 0
       then goto _18
       else goto _18;
_17:
H := 2*H;
_18:
if ( H-K ) < 0
 then goto _3
 else if ( H-K ) > 0
       then goto _19
       else goto _3;
_19:
H := K;
goto _3;
_22:
IERR := 65;
UTQS10(IERR,13) ;
_20:
INT1 := INT1*W;
INT2 := INT2*W;
if (  not ( (NI) ) ) 
 then goto _21;
C := B;
B := A;
A := C;
_21:
end;

end.
